cdac.medinfo.sdk.hl7282.baselibs

## Class HD

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.CompositeDataType
  - - cdac.medinfo.sdk.hl7282.baselibs.HD

- All Implemented Interfaces:
    IDataType

      public class HD
      extends CompositeDataType

  HD - Hierarchic Designator

  This data type identifies an (administrative or system or application or other) entity that has responsibility for managing or assigning a defined set of instance identifiers (such as placer or filler number, patient identifiers, provider identifiers, etc.)

  Represents an HL7 HD data type. This data type has the following attributes:

  1. Namespace ID (IS)Optional
  2. Universal ID (ST)Conditional
  3. Universal ID Type (ID)Conditional

  This class provides accessors & mutators for the elements mentioned above. This class override the equal method, to check whether some other object is "equal to" this one.

  User can also create Data Type through `DataElementFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `HD()` Default constructor for HD.
    `HD(int iComponentType, IDataTypeMap objIDataTypeMap)` Constructor for HD class which takes four arguments and sets the value in the respective member variable.
    `HD(int iComponentType, int iMinLength, int iMaxLength, java.lang.String strCLength, IDataTypeMap objIDataTypeMap)` Constructor for TS class which takes five arguments and sets the value in the respective member variable.
    `HD(int iComponentType, int iMinLength, int iMaxLength, java.lang.String strCLength, int ITableNo, IDataTypeMap objIDataTypeMap)` Constructor for HD class which takes six arguments and sets the value in the respective member variable.
    `HD(int iMinLength, int iMaxLength, java.lang.String strCLength, int iComponentType)` Constructor for HD class which takes four arguments and sets the value in the respective member variable.
    `HD(int iMinLength, int iMaxLength, java.lang.String strCLength, int iTableNo, int iComponentType)` Constructor for HD class which takes five arguments and sets the value in the respective member variable.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object objObject)` This method checks the equality of Object.
    `IS` | `getNamespaceID()` Returns Namespace ID
    `ST` | `getUniversalID()` Returns Universal ID
    `ID` | `getUniversalIDType()` Returns Universal ID Type
    `void` | `setNamespaceId(IS objIS)` Sets the NamespaceId.
    `void` | `setNamespaceId(java.lang.String strNamespaceId)` Sets the NamespaceId.
    `void` | `setUniversalId(ST objST)` Sets the UniversalId.
    `void` | `setUniversalId(java.lang.String strUniversalId)` Sets the UniversalId.
    `void` | `setUniversalIdType(ID objID)` Sets the UniversalIdType.
    `void` | `setUniversalIdType(java.lang.String strUniversalIdType)` Sets the UniversalIdType.
    `boolean` | `validate()` The Method validates the Input value,and if validated properly then returns true.

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.CompositeDataType

      `copy, dumpDataType, getAttributes, getDataTypeName, getLength, getValue, isPrimitive, read, setValue, write, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### HD

          public HD()

      Default constructor for HD.

    - #### HD

          public HD(int iMinLength,
            int iMaxLength,
            java.lang.String strCLength,
            int iComponentType)
             throws InvalidComponentTypeException

      Constructor for HD class which takes four arguments and sets the value in the respective member variable.
      Parameters:
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### HD

          public HD(int iMinLength,
            int iMaxLength,
            java.lang.String strCLength,
            int iTableNo,
            int iComponentType)

      Constructor for HD class which takes five arguments and sets the value in the respective member variable.
      Parameters:
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### HD

          public HD(int iComponentType,
            IDataTypeMap objIDataTypeMap)

      Constructor for HD class which takes four arguments and sets the value in the respective member variable.
      Parameters:
        `objIDataTypeMap` - object of Data Type Map.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### HD

          public HD(int iComponentType,
            int iMinLength,
            int iMaxLength,
            java.lang.String strCLength,
            IDataTypeMap objIDataTypeMap)

      Constructor for TS class which takes five arguments and sets the value in the respective member variable.
      Parameters:
        `objIDataTypeMap` - object of Data Type Map.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### HD

          public HD(int iComponentType,
            int iMinLength,
            int iMaxLength,
            java.lang.String strCLength,
            int ITableNo,
            IDataTypeMap objIDataTypeMap)

      Constructor for HD class which takes six arguments and sets the value in the respective member variable.
      Parameters:
        `objIDataTypeMap` - object of Data Type Map.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
        `iTableNo` - The Table number to which the value for the component is specified.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

  - ### Method Detail

    - #### setNamespaceId

          public void setNamespaceId(java.lang.String strNamespaceId)

      Sets the NamespaceId.
      Parameters:
        `strNamespaceId` - Specifies Specifies the HL7 identifier for the user-defined table of values for this component.[Refer Table No.300]

    - #### setNamespaceId

          public void setNamespaceId(IS objIS)

      Sets the NamespaceId.
      Parameters:
        `objIS` - Specifies Specifies the HL7 identifier for the user-defined table of values for this component.[Refer Table No.300]

    - #### setUniversalId

          public void setUniversalId(java.lang.String strUniversalId)

      Sets the UniversalId.
      Parameters:
        `strUniversalId` - Specifies a string formatted according to the scheme defined by the component, (UID type).

    - #### setUniversalId

          public void setUniversalId(ST objST)

      Sets the UniversalId.
      Parameters:
        `objST` - Specifies a string formatted according to the scheme defined by the component, (UID type).

    - #### setUniversalIdType

          public void setUniversalIdType(java.lang.String strUniversalIdType)

      Sets the UniversalIdType.
      Parameters:
        `strUniversalIdType` - Governs the voiderpretation of the strUniversalId.

    - #### setUniversalIdType

          public void setUniversalIdType(ID objID)
                                  throws InvalidDataTypeException

      Sets the UniversalIdType.
      Parameters:
        `objID` - Governs the voiderpretation of the strUniversalId.
      Throws:
        `InvalidDataTypeException`

    - #### getNamespaceID

          public IS getNamespaceID()

      Returns Namespace ID
      Returns:
        IS - data type.

    - #### getUniversalID

          public ST getUniversalID()

      Returns Universal ID
      Returns:
        ST - data type.

    - #### getUniversalIDType

          public ID getUniversalIDType()

      Returns Universal ID Type
      Returns:
        ID - data type.

    - #### validate

          public boolean validate()
                           throws InvalidDataTypeException

      The Method validates the Input value,and if validated properly then returns true. Here the validetion is based on the compulsory fields for the Datatype.
      Specified by:
        `validate` in interface `IDataType`
      Overrides:
        `validate` in class `CompositeDataType`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidDataTypeException` - - if Invalid values is entered or Mandatory field is missing.

    - #### equals

          public boolean equals(java.lang.Object objObject)

      This method checks the equality of Object.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `objObject` - object of Object class.
      Returns:
        boolean - shows success or failure of the comparison.